@echo off

title UltraPath_Unattend_Installation
set script_dir=%~dp0
set script_dir=%script_dir:~0,-1%
set "script_dir=%script_dir%"
set ultrapathExe_dir=%script_dir%\..
set "ultrapathExe_dir=%ultrapathExe_dir%"
set ISSetupLogDir=""
set countLineNum=0
set UAISetupLog=UAISetup.log
set unrebootInfo=Install UltraPath successfully. Unattend installation configuration item 'restart' set to 'N/n'. You must restart your system for the configuration changes made to UltraPath to take effect.
set rebootInfo=Install UltraPath successfully. Unattend installation configuration item 'restart' set to 'Y/y'. The system will be restarted after the unattend installation.
set outtimeInfo=UltraPath installation times out. Please remotely log in to the Windows desktop to rectify the fault. If the fault persists, contact technical support engineers.
set moreProcessInfo=Only a single instance of the UltraPath unattend installation program can run.
set processInfo=Unattend installation is running. Do not operate this window...
set outtimesegmentpoint=40
set outtimecomparenum=20
set onehour=60
set runbatnum=0

for /f "tokens=*" %%i in ( 'tasklist /v ^| find /i "cmd" ^| find /i /c "UltraPath_Unattend_Installation"' ) do (   
    set /a runbatnum=%%i
)
cls

if %runbatnum% gtr 1 (
    echo %moreProcessInfo%
    goto checkRunProcessNum
)

reg query HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\nxup /ve > nul
if %errorlevel%==0 (
    cls
    echo UltraPath has been installed and unattend installation exits. 
    goto end
)
cls

pushd %ultrapathExe_dir%
for %%i in (UltraPath*.exe) do ( 
    set ultrapath_name=%%i  
) 
popd

if not exist unattend_install.conf (
    echo The specified configuration file unattend_install.conf cannot be found.
    goto end
)
if not exist unattend_install_reboot.iss (
    echo The specified configuration file unattend_install_reboot.iss cannot be found.
    goto end
)
if not exist unattend_install_unreboot.iss (
    echo The specified configuration file unattend_install_unreboot.iss cannot be found.
    goto end
)
    
if exist unattend_install.log (
    del unattend_install.log /f /q
)

findstr . "unattend_install.conf">nul  && set count=0 || set count=1
if %count%==1 (
    cls
    echo  The unattend_install.conf file is empty.
    goto end 
)

findstr . "unattend_install_reboot.iss">nul  && set count=0 || set count=1
if %count%==1 (
    echo  The unattend_install_reboot.iss file is empty.
    goto end 
)

findstr . "unattend_install_unreboot.iss">nul  && set count=0 || set count=1
if %count%==1 (
    echo  The unattend_install_unreboot.iss file is empty.
    goto end 
)

for /f "eol=; tokens=2,2 delims==" %%i in ('findstr /i "restart" unattend_install.conf') do (   
    set isReboot=%%i  
    set /a countLineNum+=1
)

set "isReboot=%isReboot: =%"
set "isReboot=%isReboot:	=%"

if %countLineNum% gtr 1 (
    echo  The value of a configuration item is incorrect.
    goto end
)

if "s%isReboot%"=="sN" (
    goto runinstall
)

if "s%isReboot%"=="sn" (
    goto runinstall
)

if "s%isReboot%"=="sY" (
    goto runinstall
)

if "s%isReboot%"=="sy" (
    goto runinstall
)

echo  The value of a configuration item is incorrect.  
goto end

:runinstall

echo %time:~0,8% > record_start.txt
for /f "tokens=1,2 delims=:" %%a in (record_start.txt) do (
    set start_hour=%%a
    set start_minute=%%b
)

if  %start_minute% lss %outtimesegmentpoint% (
    set /a end_minute=%start_minute%+%outtimecomparenum%
) else (
    set /a end_minute=%start_minute%+%outtimecomparenum%-%onehour%
)

if exist record_start.txt (
    del record_start.txt /f /q
)

tasklist | find /i "%ultrapath_name%" > nul
if %errorlevel% == 0 (
    echo %moreProcessInfo%
    goto checkRunProcessNum
) 

pushd %ultrapathExe_dir%
if %isReboot%==N (start %ultrapath_name% /s /f1"%script_dir%\unattend_install_unreboot.iss" /f2"%script_dir%\unattend_install.log")
if %isReboot%==n (start %ultrapath_name% /s /f1"%script_dir%\unattend_install_unreboot.iss" /f2"%script_dir%\unattend_install.log")
if %isReboot%==Y (start %ultrapath_name% /s /f1"%script_dir%\unattend_install_reboot.iss" /f2"%script_dir%\unattend_install.log") 
if %isReboot%==y (start %ultrapath_name% /s /f1"%script_dir%\unattend_install_reboot.iss" /f2"%script_dir%\unattend_install.log")
popd

:loop

echo %time:~0,8% > record_cur.txt
for /f "tokens=1,2 delims=:" %%a in (record_cur.txt) do (
    set current_hour=%%a
    set current_minute=%%b
)

if  %start_minute% lss %outtimesegmentpoint% (
    if %current_minute% geq %end_minute% (
        echo  %outtimeInfo%
        if exist record_cur.txt (
            del record_cur.txt /f /q
        )
        goto outtime
    )
) else (
    if %current_minute% lss %outtimecomparenum% (
        if %current_minute% geq %end_minute% (
            echo  %outtimeInfo%
            if exist record_cur.txt (
                del record_cur.txt /f /q
            )
            goto outtime
        )
    )
)

if exist record_cur.txt (
    del record_cur.txt /f /q
)

reg query HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\uppath /ve > nul
if %errorlevel% neq 0 (
    cls
    echo %processInfo%
    ping 127.0.0.1 -n 3 >nul
    goto loop
)
cls
for /f "tokens=1,2 delims=:" %%a in ('reg query HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\uppath /v LogPath') do (
    set "ISSetupLogDirL=%%a"
    set "ISSetupLogDirR=%%b"
    
)
set ISSetupLogDir="%ISSetupLogDirL:~-1%:%ISSetupLogDirR%"

pushd %ISSetupLogDir%
if not exist ISSetup.log (
    popd
    cls
    echo %processInfo%
    ping 127.0.0.1 -n 3 >nul
    goto loop
)
popd

if not exist unattend_install.log (
    cls
    echo %processInfo%
    ping 127.0.0.1 -n 3 >nul
    goto loop
)
    
for /f "eol=; tokens=2,2 delims==" %%i in ('findstr /i "ResultCode" unattend_install.log') do (   
    set installResult=%%i  
)

if %installResult%==0 (
    if %isReboot%==n (
        echo  %unrebootInfo%
        pushd %ISSetupLogDir%
        echo  %date% %time% %unrebootInfo% >>  %UAISetupLog%
        popd
    )
    
    if %isReboot%==N (
        echo  %unrebootInfo%
        pushd %ISSetupLogDir%
        echo  %date% %time% %unrebootInfo% >>  %UAISetupLog%
        popd
    )
    
    if %isReboot%==y (
        echo  %rebootInfo%
        pushd %ISSetupLogDir%
        echo  %date% %time% %rebootInfo% >>  %UAISetupLog%
        popd
    )
    
    if %isReboot%==Y (
        echo  %rebootInfo%
        pushd %ISSetupLogDir%
        echo  %date% %time% %rebootInfo% >>  %UAISetupLog%
        popd
    )
    goto end
) else (
    setlocal enabledelayedexpansion
    pushd %ISSetupLogDir%
    for /f "eol=; tokens=2,2 delims=:" %%i in ('findstr /i "MSG" ISSetup.log') do (   
    set abnormalMessage=%%i  
    )
    popd
    echo  Install UltraPath failed. !abnormalMessage!
    pushd %ISSetupLogDir%
    echo  %date% %time% Install UltraPath failed. !abnormalMessage! >>  %UAISetupLog%
    popd
    goto end
)
:outtime
pushd %ISSetupLogDir%
if %errorlevel% neq 0 (
    cls
    goto end
)
echo  %date% %time% %outtimeInfo% >>  %UAISetupLog%
popd
goto end
:end

if exist unattend_install.log (
   del unattend_install.log /f /q
)
:checkRunProcessNum